%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Removed_Offsets_Counter = Remove_RutFast_Offsets(Fastener_Index)

global ErrCode;

global DB_MPC;
global AT_MPC;

global DB_FASTENERS;

% Инициализация счетчиков
Removed_Offsets_Counter = 0;

% Получение оси болта
[Axis_Point_1, Axis_Point_2, Axis_vector] = Get_Fastener_Axis(Fastener_Index);

if (ErrCode < 0)
    return;
end

% Цикл по ярусам
for j=1:DB_FASTENERS{Fastener_Index}.N_layers

    % Если есть MPC для офсета
    if (~isempty(DB_FASTENERS{Fastener_Index}.Offset_MPCs{j}))

        % Удаление MPC
        MPC_list = DB_FASTENERS{Fastener_Index}.Offset_MPCs{j};

        Append_To_Output(PCL_MPC_Delete(MPC_list));
        DB_MPC_Delete(MPC_list);

        if (ErrCode < 0)
            return;
        end

        % Соединение болта с текущим ярусом сетки
        Node_To_Remove = DB_FASTENERS{Fastener_Index}.Additional_nodes(j);

        Element_list = DB_FASTENERS{Fastener_Index}.Bush_elements{j};
        Node_list = DB_FASTENERS{Fastener_Index}.Additional_nodes(j);
        Target_Node_list = DB_FASTENERS{Fastener_Index}.Joint_nodes(j);

        Append_To_Output(PCL_Elm_Modify_Conn(Element_list, Node_list, Target_Node_list));
        DB_Elm_Modify_Conn(Element_list, Node_list, Target_Node_list);

        if (ErrCode < 0)
            return;
        end

        MPC_ID = DB_FASTENERS{Fastener_Index}.RBAR_MPCs(j);
        if (DB_FASTENERS{Fastener_Index}.Additional_nodes(j) == DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.RBAR_MPCs(j))}.ind_grid)
            Ind_Node = DB_FASTENERS{Fastener_Index}.Joint_nodes(j);
            Dep_Node = DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.RBAR_MPCs(j))}.dep_grid;
            Dep_DOFs = DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.RBAR_MPCs(j))}.dep_DOF;
        else
            Ind_Node = DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.RBAR_MPCs(j))}.ind_grid;
            Dep_Node = DB_FASTENERS{Fastener_Index}.Joint_nodes(j);
            Dep_DOFs = DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.RBAR_MPCs(j))}.dep_DOF;
        end

        Append_To_Output(PCL_MPC_Modify_RBAR(MPC_ID, Ind_Node, Dep_Node, Dep_DOFs));
        DB_MPC_Modify_RBAR(MPC_ID, Ind_Node, Dep_Node, Dep_DOFs);

        if (ErrCode < 0)
            return;
        end

        MPC_ID = DB_FASTENERS{Fastener_Index}.RBAR_MPCs(j+1);
        if (DB_FASTENERS{Fastener_Index}.Additional_nodes(j) == DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.RBAR_MPCs(j+1))}.ind_grid)
            Ind_Node = DB_FASTENERS{Fastener_Index}.Joint_nodes(j);
            Dep_Node = DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.RBAR_MPCs(j+1))}.dep_grid;
            Dep_DOFs = DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.RBAR_MPCs(j+1))}.dep_DOF;
        else
            Ind_Node = DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.RBAR_MPCs(j+1))}.ind_grid;
            Dep_Node = DB_FASTENERS{Fastener_Index}.Joint_nodes(j);
            Dep_DOFs = DB_MPC{AT_MPC(DB_FASTENERS{Fastener_Index}.RBAR_MPCs(j+1))}.dep_DOF;
        end

        Append_To_Output(PCL_MPC_Modify_RBAR(MPC_ID, Ind_Node, Dep_Node, Dep_DOFs));
        DB_MPC_Modify_RBAR(MPC_ID, Ind_Node, Dep_Node, Dep_DOFs);

        if (ErrCode < 0)
            return;
        end

        % Удаление узла
        Node_list = Node_To_Remove;

        Append_To_Output(PCL_Node_Delete(Node_list));
        DB_Node_Delete(Node_list);

        if (ErrCode < 0)
            return;
        end

        % Внесение изменений в базу данных крепежа
        DB_FASTENERS{Fastener_Index}.Offset_MPCs{j} = [];
        DB_FASTENERS{Fastener_Index}.Additional_nodes(j) = DB_FASTENERS{Fastener_Index}.Joint_nodes(j);

        % Перемещение первого концевого узла
        if (j == 1)

            % Получение точек для расчета направления
            Point_1 = Get_Plate_Midsurf_Point(Fastener_Index, j, Axis_Point_1, Axis_Point_2, Axis_vector);

            if (ErrCode < 0)
                return;
            end

            Point_2 = Get_Plate_Midsurf_Point(Fastener_Index, DB_FASTENERS{Fastener_Index}.N_layers-j+1, Axis_Point_1, Axis_Point_2, Axis_vector);

            if (ErrCode < 0)
                return;
            end

            if (Equiv_Check_Cube(Point_1, Point_2))
                fprintf (1, '\nОшибка: нулевое расстояние между крайними срединными точками в болте Рутмана с номером %i !\n', Fastener_Index);
                ErrCode = -1;
                return;
            end

            % Получение знака
            Sign = sign(dot(Point_1 - Point_2, Axis_vector));

            % Толщина текущего яруса
            Plate_Thickness = Get_Plate_Thickness(Fastener_Index, j, Axis_Point_1, Axis_Point_2);

            if (ErrCode < 0)
                return;
            end

            % Координаты целевой точки
            Target_Location = Project_Point_Line(DB_FASTENERS{Fastener_Index}.Joint_nodes(j), Axis_Point_1, Axis_Point_2) + Plate_Thickness/2 * Axis_vector * Sign;

            % Проверка концевого узла
            if (~Equiv_Check_Cube(DB_FASTENERS{Fastener_Index}.Shank_nodes(1), Target_Location))

                % Перемещение узла
                Append_To_Output(PCL_Node_Move(DB_FASTENERS{Fastener_Index}.Shank_nodes(1), Target_Location));
                DB_Node_Move(DB_FASTENERS{Fastener_Index}.Shank_nodes(1), Target_Location);

                if (ErrCode < 0)
                    return;
                end

            end

        end

        % Перемещение второго концевого узла
        if (j == DB_FASTENERS{Fastener_Index}.N_layers)

            % Получение точек для расчета направления
            Point_1 = Get_Plate_Midsurf_Point(Fastener_Index, j, Axis_Point_1, Axis_Point_2, Axis_vector);

            if (ErrCode < 0)
                return;
            end

            Point_2 = Get_Plate_Midsurf_Point(Fastener_Index, DB_FASTENERS{Fastener_Index}.N_layers-j+1, Axis_Point_1, Axis_Point_2, Axis_vector);

            if (ErrCode < 0)
                return;
            end

            if (Equiv_Check_Cube(Point_1, Point_2))
                fprintf (1, '\nОшибка: нулевое расстояние между крайними срединными точками в болте Рутмана с номером %i !\n', Fastener_Index);
                ErrCode = -1;
                return;
            end

            % Получение знака
            Sign = sign(dot(Point_1 - Point_2, Axis_vector));

            % Толщина текущего яруса
            Plate_Thickness = Get_Plate_Thickness(Fastener_Index, j, Axis_Point_1, Axis_Point_2);

            if (ErrCode < 0)
                return;
            end

            % Координаты целевой точки
            Target_Location = Project_Point_Line(DB_FASTENERS{Fastener_Index}.Joint_nodes(j), Axis_Point_1, Axis_Point_2) + Plate_Thickness/2 * Axis_vector * Sign;

            % Проверка концевого узла
            if (~Equiv_Check_Cube(DB_FASTENERS{Fastener_Index}.Shank_nodes(DB_FASTENERS{Fastener_Index}.N_layers+2), Target_Location))

                % Перемещение узла
                Append_To_Output(PCL_Node_Move(DB_FASTENERS{Fastener_Index}.Shank_nodes(DB_FASTENERS{Fastener_Index}.N_layers+2), Target_Location));
                DB_Node_Move(DB_FASTENERS{Fastener_Index}.Shank_nodes(DB_FASTENERS{Fastener_Index}.N_layers+2), Target_Location);

                if (ErrCode < 0)
                    return;
                end

            end

        end

        % Проверка узла стержня болта
        if (~Equiv_Check_Cube(DB_FASTENERS{Fastener_Index}.Shank_nodes(j+1), DB_FASTENERS{Fastener_Index}.Joint_nodes(j)))

            % Перемещение узла
            Append_To_Output(PCL_Node_Move(DB_FASTENERS{Fastener_Index}.Shank_nodes(j+1), DB_FASTENERS{Fastener_Index}.Joint_nodes(j)));
            DB_Node_Move(DB_FASTENERS{Fastener_Index}.Shank_nodes(j+1), DB_FASTENERS{Fastener_Index}.Joint_nodes(j));

            if (ErrCode < 0)
                return;
            end

        end

        % Обновление счетчика
        Removed_Offsets_Counter = Removed_Offsets_Counter + 1;

    end

end
